/***************************************************************************
                          gnu_std_valarray.h  -  description
	patch for std::valarray by gnu c++ (v.2.96): 
	this functions are necessary for valarray consruct
	from slice_array, mask_array, etc
                             -------------------
    begin                : Sun Nov 17 2002
    copyright            : (c) 2002 Schetenyuk S. (sergweb@hotmail.com)
	                       (c) 2002 Dr.Bashnyakov A. (bash@unicyb.kiev.ua)
 ***************************************************************************/
   
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef patch_std_valarray_patch_std_valarray
#define patch_std_valarray_patch_std_valarray


//patch for slice_array
template<typename _Tp>
inline void
__valarray_copy_construct (_Array<_Tp> __a, size_t __n, size_t __s, _Array<_Tp> __b)
{ __valarray_copy(__a, __n, __s, __b); }

template<typename _Tp, class _Dom>
inline void __valarray_copy_construct (const _Expr<_Dom, _Tp>& __e, size_t __n, _Array<_Tp> __b )
 { __valarray_copy (__e, __n, __b); }

//patch for mask_array
template<typename _Tp>
inline void
__valarray_copy_construct (_Array<_Tp> __a, _Array<bool> __i,
                 _Array<_Tp> __b, size_t __n)
{ __valarray_copy (__a, __i, __b, __n); }

/*
//patches for another construct, don't use without necessary

template<typename _Tp>
inline void
__valarray_copy_construct (_Array<_Tp> __a, size_t __n, _Array<_Tp> __b)
{ __valarray_copy (__a, __n, __b); }

template<typename _Tp>
inline void
__valarray_copy_construct (_Array<_Tp> __a, _Array<_Tp> __b, size_t __n, size_t __s)
{ __valarray_copy (__a, __b, __n, __s); }

template<typename _Tp>
inline void
__valarray_copy_construct (_Array<_Tp> __a, _Array<size_t> __i,
                 _Array<_Tp> __b, size_t __n)
{ __valarray_copy (__a, __i, __b, __n); }

template<typename _Tp>
inline void
__valarray_copy_construct (_Array<_Tp> __a, size_t __n, _Array<_Tp> __b,
                 _Array<size_t> __i)
{ __valarray_copy (__a, __n, __b, __i); }
*/


#endif  //patch_std_valarray_patch_std_valarray


